unit NoReadOU;
// Entfernt Schreibschutz in Unterverzeichnissen
// Braucht man nach dem Datentransport mit CD

interface

procedure RemoveReadOnly;

implementation

uses Windows, SysUtils;

VAR HelpF, FragF, NoDiF, VerbF, WartF: Boolean;

FUNCTION AddBackSlash (CONST St: String): String;
// Hngt an nicht leeren Pfad "\", wenn nicht schon da
BEGIN
  IF (St <> '') AND (St [Length (St)] <> '\')
    THEN Result := St + '\'
    ELSE Result := St;
END; { AddBackSlash }

FUNCTION PathFromParamB (c: Integer; const Defau: String): String;
// Holt c-ten Parameter als Pfad
BEGIN
  IF (ParamCount < c) OR (ParamStr (c)[1] = '/')
    THEN Result := Defau
    ELSE Result := AddBackSlash (ParamStr (c));
END;

FUNCTION PathFromParam (c: Integer; const Defau: String): String;
// Holt c-ten Parameter
BEGIN
  IF (ParamCount < c) OR (ParamStr (c)[1] = '/')
    THEN Result := Defau
    ELSE Result := ParamStr (c);
END;

// Damit knnte man einzelne Umlaute ohne AnsiToOem erzeugen
// '' <<-->> $84, $94, $81, $E1, $8E, $99, $9A
//                  132, 148, 129, 225, 142, 153, 154
FUNCTION fAnsiToOem (CONST St: String): String;
BEGIN              // Im DOS-Fenster sollen Umlaute richtig erscheinen
  SetLength (Result, Length (St));
  if Result <> '' then
  AnsiToOemBuff (@St[1], @Result[1], Length (St));
END; { fAnsiToOem }

PROCEDURE WriteAnsi (Const St: String);
BEGIN
  Write (fAnsiToOem (St));
END;

PROCEDURE WriteLnAnsi (Const St: String);
BEGIN
  WriteAnsi (St); WriteLn;
END;

PROCEDURE WnA (Const St: String);
BEGIN
  WriteAnsi (St); WriteLn;
END;

PROCEDURE LnWriteAnsi (Const St: String);
BEGIN
  WriteLn; WriteAnsi (St);
END;

PROCEDURE WriteHelp;
BEGIN
  WnA ('NoReadO entfernt ReadOnly (Schreibschutz) von einer Datei');
  WnA ('  oder von allen Dateien eines Ordners (und Unterordners).');
  WnA ('');
  WnA ('Aufruf: Ziel-Datei bzw. Ziel-Ordner auf NoReadO.exe ziehen.');
  WnA ('Fr einen besonders einfachen Aufruf');
  WnA ('  einmal eine Verknpfung mit NoReadO.exe auf den Desktop legen.');
  WnA ('  Dann die Ziel-Ordner auf diese Verknpfung ziehen.');
  WnA ('');
  WnA ('Aufruf mit Parametern:  NoReadO Ziel [/Optionen]');
  WnA ('Optionen:  A=Ask   N=NoSubDir   V=Verbose   W=Wait');
  WnA ('Beispiel:  NoReadO Ordner /N    nicht in Unterverzeichnissen');
  WnA ('           Optionen kann man in der Verknpfung angeben');
  WnA ('');
  WnA ('Anregungen an: dammeier@semgym.uni-tuebingen.de');
END;

(******************************************************************************)
TYPE TDoIt = PROCEDURE (Const Di, Na: String);

PROCEDURE DoInDir (Const Dir, Wild: String; DoIt: TDoIt);
VAR SearchRec: TSearchRec;
BEGIN
    IF (FindFirst (Dir + Wild, faAnyFile, SearchRec) = 0) THEN
    REPEAT
      DoIt (Dir, SearchRec.Name);
    UNTIL FindNext (SearchRec) <> 0;
    FindClose(SearchRec);
END; { DoInDir }

PROCEDURE WalkAllSubDir (Const Dir, Wild: String; DoIt: TDoIt);
// Durchluft rekursiv Dir und alle Unterverzeichnisse
VAR SearchRec: TSearchRec;
BEGIN
  DoInDir (Dir, Wild, DoIt);
  IF FindFirst (Dir + '*.*', faDirectory, SearchRec) = 0 THEN
  REPEAT
    IF (SearchRec.Attr AND faDirectory <> 0) AND (SearchRec.Name [1] <> '.')
      THEN WalkAllSubDir (Dir + SearchRec.Name + '\', Wild, DoIt);
  UNTIL FindNext (SearchRec) <> 0;
  FindClose (SearchRec);
END; { WalkAllSubDir }

PROCEDURE RemReadOnly (Const Dir, Name: String);
BEGIN
  IF VerbF THEN WriteAnsi (' ' + Name);
  FileSetAttr(Dir + Name, FileGetAttr(Dir + Name) AND not faReadOnly);
END;

procedure RemoveReadOnly;
VAR p, i: Integer;
    ZielPfad: String;
    Inp: String;
begin
    ZielPfad := PathFromParam (1, '');
    if (ZielPfad <> '') and (ExtractFilePath (ZielPfad) = '')
      then ZielPfad := ExtractFilePath (ParamStr(0)) + ZielPfad;
    HelpF := (ZielPfad = '') OR (ZielPfad [1] = '*');
    FragF := False;
    NoDiF := False;
    VerbF := False;
    WartF := False;
    FOR p := 2 TO ParamCount DO
      IF ParamStr (p)[1] = '/'
      THEN FOR i := 2 TO Length (ParamStr (p)) DO
             CASE UpCase (ParamStr (p)[i]) OF
                '?': HelpF := True;
                'N': NoDiF := True;
                'S': FragF := True;
                'V': VerbF := True;
                'W': WartF := True;
             END;
    IF HelpF
    THEN WriteHelp
    ELSE BEGIN
           IF FragF THEN
           BEGIN
             WnA ('Aus ' + ZielPfad + ' und allen Unterverzeichnissen');
             WriteAnsi ('entfernen ??  (J/N) ');
             ReadLn (Inp);
             IF (UpperCase (Inp) <> 'J') THEN Exit;
           END;
           if FileGetAttr(ZielPfad) AND faDirectory = 0
           then RemReadOnly ('', ZielPfad)       // ist Datei und existiert
           else if NoDiF
                then DoInDir (AddBackSlash (ZielPfad), '*.*', RemReadOnly)
                else WalkAllSubDir (AddBackSlash (ZielPfad), '*.*', RemReadOnly);
         END;
    IF HelpF OR WartF
    THEN BEGIN
           LnWriteAnsi ('RETURN-Taste ');
           ReadLn;
         END;
END;

end.

